#!/bin/env python
from Tkinter import *
from tkMessageBox import *
import pyrestaure
import os
import thread

class TkArchive(Frame):
    """Affiche les donnes d'une archive"""
    def __init__(self, parent=None):
        """Construit les widgets"""
        self.archive = None
        Frame.__init__(self, parent)
        ##
        self.f00 = Frame(self, relief=RAISED)
        self.name = StringVar()
        Label(self.f00, text="Nom de l'archive:").pack(side=LEFT)
        self.nameWidget = Entry(self.f00, textvariable=self.name)
        self.nameWidget.pack(side=RIGHT)
        ##
        self.f0 = Frame(self, relief=RAISED)        
        self.comment = Text(self.f0, relief=SUNKEN,
                            height=4, width=40)
        self.comment.pack(side=TOP)
        ##
        self.f1 = Frame(self)
        Label(self.f1, text='type: ').pack(side=LEFT)
        self.typeVariable = StringVar()
        #### Ajouter ici les nouveaux types d'archives
        for type in ['dd', 'dd_zip', 'dd_sector', 'tgz']:
            Radiobutton(self.f1, variable = self.typeVariable,
                        value = type, text = type).pack(side=LEFT)
        ##
        self.f2 = Frame(self)
        Label(self.f2, text='file').pack(side=LEFT)
        self.file = StringVar()
        fileWidget = Entry(self.f2, textvariable=self.file)
        fileWidget.pack(side=RIGHT)
        ##
        self.f3 = Frame(self)
        Label(self.f3, text='dev').pack(side=LEFT)
        self.dev = StringVar()
        self.devWidget = Entry(self.f3, textvariable=self.dev)
        self.devWidget.pack(side=RIGHT)
        ##
        self.f40 = Frame(self)
        Label(self.f40, text='taille (Mo): ').pack(side=LEFT)
        self.fileSize = StringVar()
        self.fileSizeWidget = Label(self.f40,
                                    textvariable=self.fileSize)
        self.fileSizeWidget.pack(side=RIGHT)
        ##
        self.f4 = Frame(self)
        Label(self.f4, text='date cration: ').pack(side=LEFT)
        self.dateCreation = StringVar()
        self.dateCreationWidget = Label(self.f4,
                                        textvariable=self.dateCreation)
        self.dateCreationWidget.pack(side=RIGHT)
        ##
        self.f5 = Frame(self)
        Label(self.f5, text='dernire restauration: ').pack(side=LEFT)
        self.derniereRestauration = StringVar()
        self.derniereRestaurationWidget = Label(self.f5,
                                                textvariable
                                                =self.derniereRestauration)
        self.derniereRestaurationWidget.pack(side=RIGHT)
        ##
        self.f6 = Frame(self)
        Label(self.f6, text='taille (occup/total): ').pack(side=LEFT)
        self.devSize = StringVar()
        self.devSizeWidget = Label(self.f6,
                                   textvariable =self.devSize)
        self.devSizeWidget.pack(side=RIGHT)
        ##
        self.f7 = Frame(self)
        Label(self.f7, text='point de montage: ').pack(side=LEFT)
        self.devMnt = StringVar()
        self.devMntWidget = Label(self.f7,
                                   textvariable =self.devMnt)
        self.devMntWidget.pack(side=RIGHT)
        ###############
        self.f00.pack()
        self.f0.pack()
        self.f1.pack()
        self.f2.pack()
        self.f3.pack()
        self.f40.pack()                
        self.f4.pack()
        self.f5.pack()
        self.f6.pack()
        self.f7.pack()                
        self.pack()
        
    def loadArchive(self, archive):
        """Met  jour les champs  partir
        de l'archive"""
        self.archive = archive
        self.name.set(archive.name)
        self.comment.delete('1.0', END)
        self.comment.insert('1.0', archive.comment)
        self.typeVariable.set(archive.type)
        self.file.set(archive.file)
        self.fileSize.set(archive.filesize)
        self.dev.set(archive.dev)
        self.dateCreation.set(archive.creationDate)
        self.derniereRestauration.set(archive.lastRestoreDate)
        (size, mntpoint, occupe) = archive.df()
        self.devSize.set("%s - %s" % (occupe,size))
        self.devMnt.set(mntpoint)

########################################################################       
########################################################################
class TkArchiveList(Frame):
    """Affiche une liste d'archives"""
    def __init__(self, parent=None):
        self.archive = None
        self.name = None
        Frame.__init__(self, parent)
        f0 = Frame(self,relief=RAISED, border=1)
        f1 = Frame(self)
        f11 = Frame(self)
        f2 = Frame(self, relief=SUNKEN)
        f00 = Frame(f0)
        f01 = Frame(f0)
        ##
        self.message = StringVar()
        mesgBar = Label(f2, textvariable=self.message).pack(expand=YES, fill=X,
                                                       anchor=W)
        #####
        self.archiveList = pyrestaure.ArchiveList()
        sbar = Scrollbar(f00)
        self.list = Listbox(f00, relief=SUNKEN)
        sbar.config(command=self.list.yview)
        self.list.config(yscrollcommand=sbar.set)
        sbar.pack(side=LEFT, expand=YES, fill=BOTH)
        self.list.pack(side=LEFT, expand=YES, fill=Y)
        self.tkarchive = TkArchive(f01)
        self.loadArchives()
        self.list.bind('<Double-1>', self.handleList)
        ##
        restaureButton = Button(f1,
                                text='Restaure', command=self.restaure)
        restaureButton.pack(side=LEFT)
        restauredefButton = Button(f1, text='Restaure dfaut',
                                   command=self.restaureDefaults)
        restauredefButton.pack(side=LEFT)
        newButton = Button(f1, text='Nouvelle archive',
                           command=self.nouvelle)
        newButton.pack(side=LEFT)        
        delButton = Button(f1, text="Supprimer",
                           command=self.supprime)
        delButton.pack(side=LEFT)
        self.defaut = IntVar()
        defautButton = Checkbutton(f1, text='Restauration par dfaut',
                                   variable = self.defaut,
                                   command = self.setDefaut).pack(side=LEFT)
        ##
        self.shutdown = StringVar()
        Radiobutton(f11, text='linux', variable = self.shutdown,
                    value='linux').pack(side=LEFT)
        Radiobutton(f11, text='arrt', variable = self.shutdown,
                    value='arrt').pack(side=LEFT)
        Radiobutton(f11, text='reboot', variable = self.shutdown,
                    value='reboot').pack(side=LEFT)
        self.shutdown.set('linux')
        ### Pack
        f00.pack(side=LEFT, expand=YES, fill=Y)
        f01.pack(side=RIGHT, expand=YES, fill=BOTH)
        f0.pack(side=TOP, expand=YES, fill=BOTH)
        f1.pack(side=TOP, expand=YES, fill=X)
        f11.pack(side=TOP, expand=YES, fill=X)
        f2.pack(side=BOTTOM, expand=YES, fill=X, anchor=W)
        self.pack(expand=YES, fill=BOTH)

    def loadArchives(self):
        """ Charge les archives"""
        self.list.delete(0, END)
        pos = 0
        for name, archive in self.archiveList.archives.items():
            self.list.insert(pos, name)
            self.tkarchive.loadArchive(archive)
            pos += 1

    def supprime(self):
        """Supprime l'archive slectionne"""
        self.archiveList.delete(self.name)
        self.loadArchives()


    def setDefaut(self):
        """Archive par dfaut en fonction du checkbox"""
        defaut = self.defaut.get()
        self.archiveList.setDefault(self.name, defaut)
        self.loadArchives()
        
    def restaure(self):
        """Restaure l'archive slectionne"""
        if askyesno('Restauration', 'Restauration de %s ?' % self.archive):
            self.message.set("Restauration en cours .....")
            self.archive.restore()
            self.message.set("Restauration termine")
            self.archiveList.writeConfig()
            if self.shutdown.get() == 'arrt':
                os.system("halt")
            elif self.shutdown.get() == 'reboot':
                os.system("reboot")
            else:
                pass
        else:
            pass

    def restaureDefaults(self):
        """Restaure les archives avec le marqueur default = 1"""
        if askyesno('Restauration dfauts',
                    'Restaurations des archives par dfaut ?'):
            self.message.set("Restauration des archives par dfaut ...")
            self.archiveList.restoreDefaults()
            self.message.set("Restauration termine")
            self.loadArchives()
                    
    def nouvelle(self):
        """Cration d'une nouvelle archive"""
        name = self.tkarchive.name.get()
        comment = self.tkarchive.comment.get('1.0', END+'-1c')
        type = self.tkarchive.typeVariable.get()
        default = self.defaut.get()
        file = self.tkarchive.file.get()
        dev = self.tkarchive.dev.get()
        if askyesno("Cration de l'archive",
                    """
                    nom = %s
                    commentaire = %s
                    type = %s
                    defaut = %s""" % (name, comment,
                                      type, default)):
            self.message.set("Cration de l'archive ...")
            self.archiveList.makeNewArchive(type, name,
                                            comment, file,
                                            dev,
                                            default)
        self.loadArchives()
        self.message.set("Archive cre")

            
    def handleList(self, event):
        """Appel lors d'une slection dans la liste"""
        index = self.list.curselection()
        self.name = self.list.get(index)
        self.archive = self.archiveList.archives[self.name]
        self.tkarchive.loadArchive(self.archive)
        print "defaut = %s" % self.archive.default
        self.defaut.set(self.archive.default)
    

if __name__ == '__main__':
    """Construit la fentre principale"""
    root = Tk()
    listarchives = TkArchiveList(root)
    root.mainloop()
    
