#! /bin/env python
import dialog
import pyrestaure
import os
import string

""" Effectue les sauvegardes initiales du secteur de boot
et de la partition windows """

# La partition o se trouve le secteur de boot et la table de partitions
partboot = '/dev/hda'
# Le rpertoire des sauvegardes
rep_sauve = '/sauvegarde'


d = dialog.Dialog()


def main():

    lines = os.popen("df -h | sort").readlines()
    partitions = []
    for l in lines[:-1]:
        if not l.startswith("/dev/"): continue
        (dev, size, util, disp, percent, mntpoint) = string.split(l)
        infos = "%s %s %s" % (util, disp, mntpoint)
        partitions.append((dev, infos))
    (code, partwin) = d.menu("Choisir la partition windows",
                             choices=partitions)
    if code == 1: return
    (code, typewin) = d.menu("Type de sauvegarde",
                            choices = [("dd", "copie bloc  bloc"),
                                       ("dd_zip", "copie bloc  bloc zipp"),
                                       ("tgz", "archive tar zippe")])
    if code == 1: return
    (code, action) = d.menu("Reboot ?",
                            choices = [("linux", "rester sous linux"),
                                       ("reboot", "rebooter aprs sauvegarde"),
                                       ("halt", "arrt aprs sauvegarde")
                                       ])
    if code == 1: return
    archives = pyrestaure.ArchiveList()
    d.infobox("Sauvegarde secteur de boot")
    bootfile = rep_sauve + '/bootsector.ddsector'
    archives.makeNewArchive('dd_sector', 'boot', 'secteur de boot',
                            bootfile, partboot, default='0')
    d.infobox("Sauvegarde de la table des partitions")
    partfile = rep_sauve + '/parttable.ddsector'
    archives.makeNewArchive('dd_sector', 'parttable', 'table des partitions',
                            partfile, partwin, default='0')
    d.infobox("Sauvegarde initiale de la partition windows")
    winfile = rep_sauve + '/win_ini.' + typewin
    archives.makeNewArchive(typewin, 'win_ini', 'Windows initial',
                            winfile, partwin, default='1')
    
    if action == "reboot":
        os.system("reboot")
    elif action == "halt":
        os.system("halt")
    else:
        return


main()
        
                        
